'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var _utilsGetFunctionParams = require('./utils/getFunctionParams');

var _utilsGetFunctionParams2 = _interopRequireDefault(_utilsGetFunctionParams);

var ArrowFunctionExpression = (function (_Expression) {
    _inherits(ArrowFunctionExpression, _Expression);

    function ArrowFunctionExpression(childNodes) {
        _classCallCheck(this, ArrowFunctionExpression);

        _get(Object.getPrototypeOf(ArrowFunctionExpression.prototype), 'constructor', this).call(this, 'ArrowFunctionExpression', childNodes);
    }

    _createClass(ArrowFunctionExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var params = [];
            var async = false;

            if (children.isToken('Identifier', 'async')) {
                async = true;
                children.passToken('Identifier', 'async');
                children.skipNonCode();
            }

            if (children.isToken('Punctuator', '(')) {
                params = (0, _utilsGetFunctionParams2['default'])(children);
                children.skipNonCode();
            } else if (children.currentElement.isPattern) {
                params.push(children.currentElement);
                children.moveNext();
                children.skipNonCode();
            }

            children.passToken('Punctuator', '=>');
            children.skipNonCode();

            var expression = !children.currentElement.isStatement;

            var body = undefined;
            if (expression) {
                body = children.passExpression();
            } else {
                body = children.passStatement();
            }

            children.assertEnd();

            this._async = async;
            this._params = params;
            this._body = body;
            this._expression = expression;
        }
    }, {
        key: 'async',
        get: function get() {
            return this._async;
        }
    }, {
        key: 'params',
        get: function get() {
            return this._params.concat();
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }, {
        key: 'expression',
        get: function get() {
            return this._expression;
        }
    }, {
        key: 'id',
        get: function get() {
            return null;
        }
    }, {
        key: 'generator',
        get: function get() {
            return false;
        }
    }]);

    return ArrowFunctionExpression;
})(_Expression3['default']);

exports['default'] = ArrowFunctionExpression;
module.exports = exports['default'];