'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var _utilsGetFunctionParams = require('./utils/getFunctionParams');

var _utilsGetFunctionParams2 = _interopRequireDefault(_utilsGetFunctionParams);

var FunctionExpression = (function (_Expression) {
    _inherits(FunctionExpression, _Expression);

    // TODO: get params from Property in case of setter

    function FunctionExpression(childNodes) {
        _classCallCheck(this, FunctionExpression);

        _get(Object.getPrototypeOf(FunctionExpression.prototype), 'constructor', this).call(this, 'FunctionExpression', childNodes);
        this._short = false;
        this._generatorFromProperty = false;
    }

    _createClass(FunctionExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var params = [];
            var id = null;
            var generator = false;
            var async = false;
            var short = false;

            if (children.isToken('Punctuator', '(')) {
                params = (0, _utilsGetFunctionParams2['default'])(children);
                children.skipNonCode();
            } else {
                if (children.isToken('Identifier', 'async')) {
                    async = true;
                    children.passToken('Identifier', 'async');
                    children.skipNonCode();
                }

                children.passToken('Keyword', 'function');
                children.skipNonCode();

                if (children.isToken('Punctuator', '*')) {
                    generator = true;
                    children.moveNext();
                    children.skipNonCode();
                }

                if (children.isNode('Identifier')) {
                    id = children.passNode();
                    children.skipNonCode();
                }

                params = (0, _utilsGetFunctionParams2['default'])(children);
                children.skipNonCode();
            }

            var body = children.passStatement();

            children.assertEnd();

            this._async = async;
            this._id = id;
            this._params = params;
            this._body = body;
            this._generator = generator;
            this._short = short;
        }
    }, {
        key: '_onSetParentElement',
        value: function _onSetParentElement(parentElement) {
            if (parentElement && (parentElement.type === 'Property' || parentElement.type === 'MethodDefinition')) {
                this._short = true;
                this._generatorFromProperty = parentElement._generator;
            } else {
                this._short = false;
                this._generatorFromProperty = false;
            }
        }
    }, {
        key: 'async',
        get: function get() {
            return this._async;
        }
    }, {
        key: 'params',
        get: function get() {
            return this._params.concat();
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }, {
        key: 'expression',
        get: function get() {
            return false;
        }
    }, {
        key: 'id',
        get: function get() {
            return this._id;
        }
    }, {
        key: 'generator',
        get: function get() {
            return this._short ? this._generatorFromProperty : this._generator;
        }
    }]);

    return FunctionExpression;
})(_Expression3['default']);

exports['default'] = FunctionExpression;
module.exports = exports['default'];