'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var getterAndSetter = {
    get: true,
    set: true
};

var Property = (function (_Node) {
    _inherits(Property, _Node);

    function Property(childNodes) {
        _classCallCheck(this, Property);

        _get(Object.getPrototypeOf(Property.prototype), 'constructor', this).call(this, 'Property', childNodes);
    }

    _createClass(Property, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var key = undefined;
            var value = undefined;
            var generator = false;
            var shorthand = false;
            var method = false;
            var computed = false;
            var kind = undefined;

            if (children.isToken('Identifier', getterAndSetter)) {
                kind = children.currentElement.value;
                children.passToken();
                children.skipNonCode();

                computed = children.isToken('Punctuator', '[');
                key = readKey(children);
                children.skipNonCode();

                value = children.passNode('FunctionExpression');
            } else {
                if (children.isToken('Punctuator', '*')) {
                    children.passToken();
                    children.skipNonCode();
                    generator = true;
                }

                kind = 'init';
                computed = children.isToken('Punctuator', '[');
                key = readKey(children);

                if (children.isEnd && key.type === 'Identifier') {
                    shorthand = true;
                    value = key;
                } else {
                    children.skipNonCode();
                    if (children.isNode('FunctionExpression')) {
                        method = true;
                        value = children.passNode('FunctionExpression');
                    } else {
                        children.passToken('Punctuator', ':');
                        children.skipNonCode();
                        if (children.currentElement.isPattern) {
                            value = children.passPattern();
                        } else {
                            value = children.passExpression();
                        }
                    }
                }
            }

            children.assertEnd();

            this._generator = generator;
            this._kind = kind;
            this._key = key;
            this._value = value;
            this._shorthand = shorthand;
            this._computed = computed;
            this._method = method;
        }
    }, {
        key: 'key',
        get: function get() {
            return this._key;
        }
    }, {
        key: 'value',
        get: function get() {
            return this._value;
        }
    }, {
        key: 'kind',
        get: function get() {
            return this._kind;
        }
    }, {
        key: 'shorthand',
        get: function get() {
            return this._shorthand;
        }
    }, {
        key: 'method',
        get: function get() {
            return this._method;
        }
    }, {
        key: 'computed',
        get: function get() {
            return this._computed;
        }
    }]);

    return Property;
})(_Node3['default']);

exports['default'] = Property;

function readKey(children) {
    if (children.isNode('Literal') || children.isNode('Identifier')) {
        return children.passNode();
    } else {
        children.passToken('Punctuator', '[');
        children.skipNonCode();
        var result = children.passExpression();
        children.skipNonCode();
        children.passToken('Punctuator', ']');
        return result;
    }
}
module.exports = exports['default'];